/*********************************************************
 *
 * This source code is part of the Carnegie Mellon Robot
 * Navigation Toolkit (CARMEN)
 *
 * CARMEN Copyright (c) 2002 Michael Montemerlo, Nicholas
 * Roy, and Sebastian Thrun
 *
 * CARMEN is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public 
 * License as published by the Free Software Foundation; 
 * either version 2 of the License, or (at your option)
 * any later version.
 *
 * CARMEN is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied 
 * warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 * PURPOSE.  See the GNU General Public License for more 
 * details.
 *
 * You should have received a copy of the GNU General 
 * Public License along with CARMEN; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place, 
 * Suite 330, Boston, MA  02111-1307 USA
 *
 ********************************************************/

/***********************************
 * map_editor_menus implements the *
 * menu items in the map_editor    *
 ***********************************/
#ifndef MAP_EDITOR_MENUS_H
#define MAP_EDITOR_MENUS_H

#ifdef __cplusplus
extern "C" {
#endif

/* file */

int map_open(char *filename, int have_graphics);
void open_map_menu(GtkWidget *w, gpointer data);
void new_map_menu(GtkWidget *w, gpointer data);
void save_map_menu(GtkWidget *w, gpointer data);
void save_map_as_menu(GtkWidget *w, gpointer data);
void quit_menu(GtkWidget *w, gpointer data);
void undo_menu(GtkWidget *w, gpointer data);
void help_menu(GtkWidget *w, gpointer data);
void toggle_view(GtkWidget *w, gpointer arg);
void add_placename(GtkWidget *w, gpointer arg);
void delete_placename(GtkWidget *w, gpointer arg);
void do_delete_placename(int i);
void start_add_placename(double x, double y);

#ifdef __cplusplus
}
#endif

#endif
