#ifndef CARMEN_RFLEX_COMMANDS_H
#define CARMEN_RFLEX_COMMANDS_H

#ifdef __cplusplus
extern "C" {
#endif

  int carmen_rflex_open_connection(char *dev_name, int *fd);

  void carmen_rflex_sonars_on(int fd);
  void carmen_rflex_sonars_off(int fd);

  void carmen_rflex_brake_on(int fd);
  void carmen_rflex_brake_off(int fd);

  void carmen_rflex_odometry_off( int fd );
  void carmen_rflex_odometry_on( int fd, long period );

  void carmen_rflex_initialize(int fd, int trans_acceleration,
			       int rot_acceleration,
			       int trans_pos,
			       int rot_pos);

  void carmen_rflex_update_status(int fd, int *distance, 
				  int *bearing, int *t_vel,
				  int *r_vel);

  void carmen_rflex_update_system(int fd, int *battery,
				  int *timestamp, int *brake);

  void carmen_rflex_update_sonar(int fd, int num_sonars,
				 int *ranges);
  void carmen_rflex_update_bumpers(int fd, int num_bumpers,
				   char *values);
  void carmen_rflex_update_ir(int fd, int num_irs,
			     int *ranges);

  void carmen_rflex_set_velocity(int fd, long t_vel, long r_vel, 
				 long acceleration);
  void carmen_rflex_stop_robot(int fd, int deceleration);

#ifdef __cplusplus
}
#endif

#endif
